﻿@page "/"
@using Wrnu.Were.Model
@using Wrnu.Were.Ui.Models
@inject HttpClient Http

@if(listOfObjects == null){
    <p>Laddar...</p>
}
else
{
    @if (listOfObjects.Count == 0)
    {
        <p>Inget resultat</p>
    }
    else
    {
        <TreeView Nodes="listOfObjects"
                  GetChildNodes="@(item => (item?.Children ?? new List<GameTreeNode>()).OrderBy(node => node.Created))"
                  HasChildNodes="@(item => item?.Children?.Any() == true)"
                  @bind-SelectedNode="selectedNode"
                  @bind-ExpandedNodes="ExpandedNodes"
                  >
            <NodeContent >
                @if (@context.Url is null)
                {
                    <span @onclick="() => AddOrRemove(context)">@context.DisplayName</span>
                }
                else
                {
                    <NavLink href="@context.Url">@context.DisplayName</NavLink>
                }
                
            </NodeContent>
        </TreeView>
    }
    
}

@code{
    private List<GameTreeNode>? listOfObjects; 
    
    IList<GameTreeNode?> ExpandedNodes = new List<GameTreeNode?>();
    GameTreeNode? selectedNode;

    public void Test()
    {
        var node = selectedNode;
        Console.WriteLine($"Test: {node?.DisplayName}");
        
        if (ExpandedNodes.Any(n => n?.DisplayName?.Equals(node.DisplayName) ?? false))
        {
            ExpandedNodes.Remove(node);
        }
        else
        {
            ExpandedNodes.Add(node);
        }
    } 
    
    protected void AddOrRemove(GameTreeNode node)
    {
        Console.WriteLine($"AddOrRemove: {node.DisplayName}");

        if (ExpandedNodes.Any(n => n?.DisplayName?.Equals(node.DisplayName) ?? false))
        {
            ExpandedNodes.Remove(node);
        }
        else
        {
            ExpandedNodes.Add(node);
        }
    }
    
    protected async override Task OnInitializedAsync()
    {
        var listOfGames = await Http.GetFromJsonAsync<List<Game>>("Werewolf/GetGames/81");
        var listOfGamesArchive = await Http.GetFromJsonAsync<List<Game>>("Werewolf/GetGames/116");

        listOfObjects = new List<GameTreeNode>();
        if (listOfGames is null)
        {
            Console.WriteLine($"Inget resultat på tråd: 81");
        }
        else
        {
            foreach (var game in listOfGames)
            {
                var listOfThreads = new List<GameTreeNode>();
                foreach (var forumThread in game.Threads.OrderBy(thread => thread.Created))
                {
                    listOfThreads.Add(new GameTreeNode(forumThread.title, $"./{forumThread.thread_id}", new List<GameTreeNode>(), forumThread.Created));
                }
                listOfObjects.Add(new GameTreeNode($"{game.Name} (SL: {game.GameMaster})", null, listOfThreads, game.Created));
            }
            
            foreach (var game in listOfGamesArchive)
            {
                var listOfThreads = new List<GameTreeNode>();
                foreach (var forumThread in game.Threads.OrderBy(thread => thread.Created))
                {
                    listOfThreads.Add(new GameTreeNode(forumThread.title, $"./{forumThread.thread_id}", new List<GameTreeNode>(), forumThread.Created));
                }
                listOfObjects.Add(new GameTreeNode($"{game.Name} (SL: {game.GameMaster})", null, listOfThreads, game.Created));
            }
        }
        
        Console.WriteLine($"Items: {listOfObjects.Count}");
    }

    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        await base.OnAfterRenderAsync(firstRender);
    }




}